# vim: set sw=4 ts=4 et:

%define rev 3878

Name:           handbrake-unstable
Version:        0.9.5+%{rev}
Conflicts:      handbrake
# svn://svn.handbrake.fr/HandBrake/trunk#%{rev}
Source:         HandBrake-svn%{rev}.tar.bz2
Release:        1.13
Summary:        Multithreaded Video Transcoder
Source99:       handbrake-unstable-rpmlintrc
Source101:      http://download.handbrake.fr/handbrake/contrib/a52dec-0.7.4.tar.gz
Source102:      http://download.handbrake.fr/handbrake/contrib/faac-1.28.tar.gz
Source103:      http://download.handbrake.fr/handbrake/contrib/faad2-2.7.tar.gz
Source104:      http://download.handbrake.fr/handbrake/contrib/ffmpeg-git-0b32da9.tar.bz2
Source105:      http://download.handbrake.fr/handbrake/contrib/lame-3.98.tar.gz
Source106:      http://download.handbrake.fr/handbrake/contrib/libdca-r81-strapped.tar.gz
Source107:      http://download.handbrake.fr/handbrake/contrib/libdvdnav-svn1168.tar.gz
Source108:      http://download.handbrake.fr/handbrake/contrib/libdvdread-svn1168.tar.gz
Source109:      http://download.m0k.org/handbrake/contrib/libmkv-0.6.4.1-0-ga80e593.tar.bz2
Source110:      http://download.handbrake.fr/handbrake/contrib/libogg-1.1.3.tar.gz
Source111:      http://download.handbrake.fr/handbrake/contrib/libsamplerate-0.1.4.tar.gz
Source112:      http://download.handbrake.fr/handbrake/contrib/libtheora-1.1.0.tar.bz2
Source113:      http://download.handbrake.fr/handbrake/contrib/libvorbis-aotuv_b5.tar.gz
Source114:      http://download.handbrake.fr/handbrake/contrib/mp4v2-trunk-r355.tar.bz2
Source115:      http://download.handbrake.fr/handbrake/contrib/mpeg2dec-0.5.1.tar.gz
Source116:      http://download.handbrake.fr/handbrake/contrib/x264-r1913-5fd3dce.tar.gz
Source117:      http://download.m0k.org/handbrake/contrib/fontconfig-2.8.0.tar.gz
Source118:      http://download.m0k.org/handbrake/contrib/freetype-2.3.9.tar.gz
Source119:      http://download.m0k.org/handbrake/contrib/libass-0.9.9.tar.bz2
Source120:      http://download.handbrake.fr/handbrake/contrib/libbluray-0.0.1-pre-129-g67ee7bc.tar.gz
Source121:      http://download.m0k.org/handbrake/contrib/libxml2-2.7.7.tar.gz
Source151:      handbrake-ffmpeg_fix_missing_return_in_nonvoid_function.patch
URL:            http://handbrake.fr/
Group:          Productivity/Multimedia/Video/Editors and Convertors
License:        GNU General Public License version 2 (GPL v2)
BuildRoot:      %{_tmppath}/build-%{name}-%{version}
BuildRequires:  python curl wget subversion
BuildRequires:  gtk2-devel gtkhtml2-devel libbz2-devel zlib-devel
BuildRequires:  libicu-devel libnotify-devel hal-devel
BuildRequires:  sqlite3-devel libcurl-devel libxslt-devel
BuildRequires:  gstreamer-0_10-devel gstreamer-0_10-plugins-base-devel
%if %suse_version >= 1110
BuildRequires:  libwebkit-devel
%else
BuildRequires:  WebKitGtk-devel
%endif
BuildRequires:  gcc gcc-c++ make glibc-devel yasm nasm
BuildRequires:  autoconf automake libtool intltool
BuildRequires:  update-desktop-files

%description
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

%package cli
Summary:        Multithreaded Video Transcoder
Group:          Productivity/Multimedia/Video/Editors and Convertors

%description cli
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

This package contains a command-line interface for Handbrake.




Authors:
--------
    Eric Petit <titer@m0k.org>
    Laurent Aimar <fenrir@via.ecp.fr>

%package gtk
Summary:        Multithreaded Video Transcoder
Group:          Productivity/Multimedia/Video/Editors and Convertors

%description gtk
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

This package contains a GTK+ graphical user interface for Handbrake.




Authors:
--------
    Eric Petit <titer@m0k.org>
    Laurent Aimar <fenrir@via.ecp.fr>


%prep
%if 0%{?rev:1}
%setup -q -n "HandBrake-svn%{rev}"
%else
%setup -q -n "HandBrake-%{version}"
%endif

# Copy 3rd party dependencies into expected locations:
%__mkdir download
for f in \
%{S:101} %{S:102} %{S:103} %{S:104} %{S:105} %{S:106} \
%{S:107} %{S:108} %{S:109} %{S:110} %{S:111} %{S:112} \
%{S:113} %{S:114} %{S:115} %{S:116} %{S:117} %{S:118} \
%{S:119} %{S:120} %{S:121} \
; do
    %__ln_s "$f" download/
done

# check beforehand that the versions match what the
# build system expects:
missing=$PWD/.missing
%__grep -hE '\.FETCH\.url *=' contrib/*/module.defs \
| %__awk -F' =' '{print $2}' \
| while read url; do
f=$(echo "$url" | %__sed 's|^.*/||')
    case $f in
        bzip2*|libiconv*|pthreads*|zlib*) continue ;;
    esac
    [ -e "$RPM_SOURCE_DIR/$f" ] || echo "$url">>"$missing"
done

if test -e "$missing"; then
    echo "ERROR: missing contrib source archives:" >&2
    cat "$missing" >&2
    exit 1
fi

%build
# will be removed when the makefiles are fixed, currently
# fails on openSUSE factory because of --as-needed
export SUSE_ASNEEDED=0

%__cp "%{S:151}" contrib/ffmpeg/A99-fix-missing-return-in-nonvoid-function.patch

%__mkdir build
./configure \
    --force \
    --build="$PWD/build" \
    --prefix="%{buildroot}%{_prefix}" \
    --strip="/bin/true" \
    --optimize=speed \
    --debug=max

pushd build
%__make libhb/project.h
%__make %{?jobs:-j%{jobs}}
popd #build

%install
pushd build
%__make install
popd #build

%__ln_s ghb "%{buildroot}%{_bindir}/HandBrakeGUI"

%suse_update_desktop_file -r ghb AudioVideo AudioVideoEditing

%__rm "%{buildroot}%{_datadir}/icons"/*/*.cache

%clean
%__rm -rf "%{buildroot}"

%files cli
%defattr(-,root,root)
%doc AUTHORS COPYING CREDITS NEWS THANKS
%{_bindir}/HandBrakeCLI

%files gtk
%defattr(-,root,root)
%doc AUTHORS COPYING CREDITS NEWS THANKS
%{_bindir}/HandBrakeGUI
%{_bindir}/ghb
%{_datadir}/applications/ghb.desktop
%{_datadir}/icons/*/*/apps/hb-icon.png

%changelog
* Wed Mar 23 2011 pascal.bleser@opensuse.org
- update to revision 3876:
  * LinGui: backwards compatibility fix gtk versions prior to 2.22 don't have
    gtk_widget_set/get_realized() func
  * LinGui: remove some deprecated widget properties
  * LinGui: fix incorrect base class in ghbcompositor: "works" with gtk2, but
    causes error in gtk3
  * LinGui: don't use private gtk_marshal_* functions: they are not exported in
    gtk+-3, so create our own marshalers
* Tue Mar 22 2011 pascal.bleser@opensuse.org
- update to revision 3870:
  * many gtk fixes
  * remove legacy %% to RF mapping: although the %% option has been gone for a
    while in the cli and gui's, there were some mappings happening in libhb and
    for preset imports; this removes the last vestages of %% quality mapping
* Sat Mar 19 2011 pascal.bleser@opensuse.org
- update to revision 3853:
  * add mpeg-2 encoding support to libhb, cli, and lingui
  * use TEMP or TEMPDIR environment variables for location of tmp directory;
    falls back to /tmp if neither are set
  * add support for DTS-HD High Resolution Audio for BD streams
* Mon Mar 14 2011 pascal.bleser@opensuse.org
- update to revision 3849:
  * fix 2 pass cfr x264 crash: an error in interjob->vrate calculation lead to
    specifying a different timebase for the 1st and 2nd pass which x264 does
    not allow. This improves the interjob->vrate calculation accuracy and also
    guarantees the timebase is the same on both passes regardless of the
    calculations accuracy.
  * fix source dimensions problem with some mpeg2 streams: was using the
    incorrect field for actual "display" dimensions of video. The field I was
    using is most often used for pan and scan which crops a 16:9 image to fit a
    4:3 display.
* Sat Mar 12 2011 pascal.bleser@opensuse.org
- update to revision 3841:
  * fix potential infinite loop in ffmpeg mpeg-4 b-frame handling
* Sat Mar 12 2011 pascal.bleser@opensuse.org
- update to revision 3840
* Wed Mar  9 2011 pascal.bleser@opensuse.org
- update to revision 3833
- bumped release to 0.9.5+...
* Tue Mar  1 2011 pascal.bleser@opensuse.org
- update to revision 3822
* Sat Dec 18 2010 pascal.bleser@opensuse.org
- update to revision 3711
* Thu Dec  2 2010 pascal.bleser@opensuse.org
- update to revision 3697
* Wed Dec  1 2010 pascal.bleser@opensuse.org
- update to revision 3696
* Fri Nov 27 2009 pascal.bleser@opensuse.org
- update to 0.9.4
* Sun Nov  1 2009 pascal.bleser@opensuse.org
- update to snapshot 2907
* Thu Oct  1 2009 pascal.bleser@opensuse.org
- downgrade to snapshot rev 2845 as per upstream request
- fix version display
- use upstream compiler flags as per upstream request
* Fri Sep 25 2009 pascal.bleser@opensuse.org
- update to rev 2844:
  * [2844] bump libtheora to official 1.1 release
  * [2843] fix srt track stop time; srt stop time was being set to the end of the start chapter instead of the end of the stop chapter
  * [2842] theora: improvements to our theora implementation:
    + support 2-pass mode which is new to theora 1.1
    + set soft target rate control so that single pass abr behaves more like theora 1.0 and doesn't look quite so awful
  * [2841] don't remove srt subs when changing from mkv to mp4
  * [2836] bump x264 to r1271 make changes required by the x264 api change fix some build issues that the x264 bump exposed
  * [2831] fix bug that was causing one sec. of audio to be dropped on many ffmpeg files
* Mon Sep 14 2009 pascal.bleser@opensuse.org
- update to rev 2822:
  * [2821] dvdnav: improved patch that guarantees forward seek moves position forward; the previous patch worked only for SEEK_CUR
  * [2822] allow dvd sources that have no audio
* Sun Sep 13 2009 pascal.bleser@opensuse.org
- update to rev 2815:
  * [2796] set use m4v preference enabled by default
  * [2797] fix PAR issue with DV For some (maybe all) DV, ffmpeg doesn't give us the sample_aspect_ratio in the context; so when it's missing, try looking it up in the AVStream info
  * [2811] improve "auto" audio selection picks the "best" audio given the input codec and output formats
  * [2812] show the correct audio codec in the audio list when it has been changed because of incompatibility with source codec or output format
  * [2813] fix initialization of chapter list when editing queued job Chapter titles the user entered were lost when editing a queued job
  * [2814] fix a Gtk-CRITICAL error when editing chapter names
  * [2815] dvdnav: read error recovery - patch libdvdnav seek to guarantee the position will move forward when making a seek request to a position that is after the current position - when a read error is detected, seek forward and retry
* Sat Sep  5 2009 pascal.bleser@opensuse.org
- new package
